
#if defined(WIN32)

//#define TRACK_DOWN_MALLOC_PROBLEM
#define _CRT_SECURE_NO_DEPRECATE

typedef unsigned char		u1T;
typedef unsigned short		u2T;
typedef unsigned __int32	u4T;
typedef signed   __int32	s4T;
typedef unsigned __int64	u8T;
#else
typedef unsigned char		u1T;
typedef unsigned short		u2T;
typedef unsigned int		u4T;
typedef signed int			s4T;
typedef unsigned long long	u8T;
#endif

#define HASHSIZE 0x400

// http://java.sun.com/docs/books/vmspec/2nd-edition/html/ClassFile.doc.html

typedef enum {
	CONSTANT_Null               =  0,	// An unused constant_pool entry
	CONSTANT_Utf8               =  1,
	CONSTANT_Integer            =  3,
	CONSTANT_Float              =  4,
	CONSTANT_Long               =  5,
	CONSTANT_Double             =  6,
	CONSTANT_Class              =  7,
	CONSTANT_String             =  8,
	CONSTANT_Fieldref           =  9,
	CONSTANT_Methodref          = 10,
	CONSTANT_InterfaceMethodref = 11,
	CONSTANT_NameAndType        = 12
} constantE;

class Cclass;

typedef struct {
	constantE	tag;
	union {
		struct {
			u2T			index1;
			u2T			index2;
		} ref;
		u1T				byte;
		u2T			 	*stringP;
		int				ival;
		float			fval;
		long long		lval;
		double			dval;
		u4T				u4val;
		u8T				u8val;
		Cclass			*classP;
	} u;
} cp_infoT;

typedef struct {
	const char	*nameP;
	u4T			flags;
	s4T			variable;
	s4T			code1;
} opcodeT;

/* Access bits */

#define ACC_PUBLIC			0x0001
#define ACC_PRIVATE			0x0002
#define ACC_PROTECTED		0x0004
#define	ACC_STATIC			0x0008
#define ACC_FINAL			0x0010
#define ACC_SYNCHRONIZED	0x0020
#define ACC_VOLATILE		0x0040
#define ACC_TRANSIENT		0x0080
#define ACC_NATIVE			0x0100
#define ACC_INTERFACE		0x0200
#define ACC_ABSTRACT		0x0400
#define ACC_STRICT			0x0800
